//`define COORDINATE_NUM 7'd100

module boundary_square_detect(
input i_clk,
input i_reset,
input i_start,
input [10:0] i_vga_x,
input [10:0] i_vga_y,
input [21:0] i_up_most_point,//lower bits -- y, higher bits -- x
input [21:0] i_bottom_point,
input [21:0] i_left_most_point,
input [21:0] i_right_most_point,
output reg o_done,
output reg [21:0] test,
output reg [21:0] o_up_most_point,//lower bits -- y, higher bits -- x
output reg [21:0] o_bottom_point,
output reg [21:0] o_left_most_point,
output reg [21:0] o_right_most_point
);

reg [2:0] state;
reg [10:0] x, y;
parameter up_1 = 3'd0, up_2 = 3'd1, down_1 = 3'd2, left_1 = 3'd3, left_2 = 3'd4, right_1 = 3'd5, finish = 3'd6;
always @(posedge i_clk) begin
	if (i_reset) begin
		o_up_most_point <= 22'b1111111111111111111111;
		o_bottom_point <= 22'd0;
		o_left_most_point <= 22'b1111111111111111111111;
		o_right_most_point <= 22'd0;
		o_done <= 1'b0;
		state <= 3'd0;
		test <= 22'd0;
		x <= 11'd0;
		y <= 11'd0;
	end else if (i_start) begin
		case (state)
		up_1: begin//up most point
			o_done <= 1'b0;
			x <= i_vga_x;
			y <= i_vga_y;
			state <= up_2;
		end
		up_2: begin
			//o_up_most_point <= {i_vga_x,i_vga_y};
			
			state <= down_1;
			
			if (y < i_up_most_point[10:0]) begin
				// test <= {x, y};
				o_up_most_point <= {x, y};//test;//22'd1;
				o_done <= 1'b1;
				// state <= up_2;
			//end else begin
				// state <= down_1;
			end
		end
		down_1: begin//bottom point
			//o_up_most_point <= test;//22'd1;
			// test <= {i_vga_x, i_vga_y};
			if (y > i_bottom_point[10:0]) begin
				o_bottom_point <= {x,y};
			end
			state <= left_1;
		end
		// down_2: begin
			// state <= left_1;
		// end
		left_1: begin//left most point
			if (x < i_left_most_point[21:11]) begin
				
				o_left_most_point <= {x,y};
				//state <= left_2;
			//end else begin
				
			end
			state <= right_1;
		end
		//left_2: begin
			//o_left_most_point <= {i_vga_x,i_vga_y};
			//state <= right_1;
		//end
		right_1: begin//right most point
			if (x > i_right_most_point[21:11]) begin
				o_right_most_point <= {x,y};
			end
			state <= finish;
		end
		finish: begin
			o_done <= 1'b1;
			
			state <= up_1;
		end
		endcase
	end
end

endmodule

module multi_11bits(i_mul_a, i_mul_b, i_clk, i_rst_n, i_start, o_mul_out, o_done);
    
    input       i_clk;
    input       i_rst_n;
	input       i_start;
	input [10:0] i_mul_a, i_mul_b;
    
    output reg [21:0] o_mul_out;
	output reg        o_done;

    reg [21:0] stored0;
    reg [21:0] stored1;
    reg [21:0] stored2;
    reg [21:0] stored3;
	reg [21:0] stored4;
	reg [21:0] stored5;
	reg [21:0] stored6;
	reg [21:0] stored7;
	reg [21:0] stored8;
	reg [21:0] stored9;
	reg [21:0] stored10;

    reg [21:0] add01;
    reg [21:0] add23;
	reg [21:0] add45;
	reg [21:0] add67;
	reg [21:0] add890;
	
	reg [21:0] add0123;
	reg [21:0] add4567;
	
	reg [1:0] state;

    always @(posedge i_clk) begin
        if(i_rst_n) begin
            o_mul_out <= 22'd0;
            stored0 <= 22'd0;
            stored1 <= 22'd0;
            stored2 <= 22'd0;
            stored3 <= 22'd0;
			stored4 <= 22'd0;
            stored5 <= 22'd0;
            stored6 <= 22'd0;
            stored7 <= 22'd0;
			stored8 <= 22'd0;
            stored9 <= 22'd0;
            stored10 <= 22'd0;
            add01 <= 22'd0;
            add23 <= 22'd0;
			add45 <= 22'd0;
            add67 <= 22'd0;
			add890 <= 22'd0;
			add0123 <= 22'd0;
			add4567 <= 22'd0;
			o_done <= 1'b0;
			state <= 2'd0;
        end
        else if (i_start) begin
			// o_done <= 1'b0;
			stored0 <= i_mul_b[0]? {11'b0, i_mul_a} : 22'b0;
			stored1 <= i_mul_b[1]? {10'b0, i_mul_a, 1'b0} : 22'b0;
			stored2 <= i_mul_b[2]? {9'b0, i_mul_a, 2'b0} : 22'b0;
			stored3 <= i_mul_b[3]? {8'b0, i_mul_a, 3'b0} : 22'b0;
			
			stored4 <= i_mul_b[4]? {7'b0, i_mul_a, 4'b0} : 22'b0;
			stored5 <= i_mul_b[5]? {6'b0, i_mul_a, 5'b0} : 22'b0;
			stored6 <= i_mul_b[6]? {5'b0, i_mul_a, 6'b0} : 22'b0;
			stored7 <= i_mul_b[7]? {4'b0, i_mul_a, 7'b0} : 22'b0;
			
			stored8 <= i_mul_b[8]? {3'b0, i_mul_a, 8'b0} : 22'b0;
			stored9 <= i_mul_b[9]? {2'b0, i_mul_a, 9'b0} : 22'b0;
			stored10 <= i_mul_b[10]? {1'b0, i_mul_a, 10'b0} : 22'b0;
			//stored11 <= i_mul_b[11]? {4'b0, i_mul_a, 7'b0} : 22'b0;

			add01 <= stored1 + stored0;
			add23 <= stored3 + stored2;
			add45 <= stored5 + stored4;
			add67 <= stored7 + stored6;
			add890 <= stored8 + stored9 + stored10;

			add0123 <= add23 + add01;
			add4567 <= add67 + add45;

			o_mul_out <= add0123 + add4567 + add890;

			case (state)
				2'd0: begin
					o_done <= 1'b0;
					state <= 2'd1;
				end
				2'd1: begin
					state <= 2'd2;
				end
				2'd2: begin
					state <= 2'd3;
				end
				2'd3: begin
					state <= 2'd0;
					o_done <= 1'b1;
				end
			endcase
        end
    end

endmodule


module radius_diff (
input i_clk,
input i_reset,
input i_start,
input [10:0] i_vga_x,
input [10:0] i_vga_y,
input [21:0] i_circle_cen,//lower bits -- y, higher bits -- x
// input [10:0] i_circle_cen_x,
// input [10:0] i_circle_cen_y,
input [21:0] i_longest_r,
input [21:0] i_shortest_r,
output reg o_done,
output reg o_work,
output reg [21:0] o_longest_r,
output reg [21:0] o_shortest_r
);
wire [10:0] delta_x, delta_y;
wire [21:0] delta_x_sqr, delta_y_sqr;
reg start;
wire x_done, y_done;

multi_11bits mul_x_sqr(
.i_clk(i_clk), 
.i_rst_n(i_reset),
.i_start(start),
.i_mul_a(delta_x), 
.i_mul_b(delta_x), 
.o_mul_out(delta_x_sqr),
.o_done(x_done)
);

multi_11bits mul_y_sqr(
.i_clk(i_clk), 
.i_rst_n(i_reset),
.i_start(start),
.i_mul_a(delta_y), 
.i_mul_b(delta_y), 
.o_mul_out(delta_y_sqr),
.o_done(y_done)
);

assign delta_x = (i_vga_x > i_circle_cen[21:11])?(i_vga_x - i_circle_cen[21:11]):(i_circle_cen[21:11] - i_vga_x);
assign delta_y = (i_vga_y > i_circle_cen[10:0])?(i_vga_y - i_circle_cen[10:0]):(i_circle_cen[10:0] - i_vga_y);
// assign delta_x = (i_vga_x > i_circle_cen_x)?(i_vga_x - i_circle_cen_x):(i_circle_cen_x - i_vga_x);
// assign delta_y = (i_vga_y > i_circle_cen_y)?(i_vga_y - i_circle_cen_y):(i_circle_cen_y - i_vga_y);
reg reset_to;
reg [2:0] state;
parameter cal_r = 3'd0, sh_1 = 3'd1, sh_2 = 3'd2, lo_1 = 3'd3, finish = 3'd4;
always @(posedge i_clk) begin
	if (i_reset) begin
		o_longest_r <= 22'd0;
		o_shortest_r <= 22'b1111111111111111111111;
		o_done <= 1'b0;
		state <= 3'd0;
		o_work <= 1'b0;
		reset_to <= 1'b1;
	end else if (i_start) begin
		case (state)
		// delta_xy: begin
			// i_vga_x > i_circle_cen[21:11]
		// end
		cal_r: begin
			o_done <= 1'b0;
			reset_to <= 1'b0;
			start <= 1'b1;
			if (x_done && y_done)
				state <= sh_1;
		end
		sh_1: begin//shortest radius
			if ((delta_x_sqr + delta_y_sqr) < i_shortest_r) begin
				state <= sh_2;
			end else begin
				state <= lo_1;
			end
		end
		sh_2: begin
			o_shortest_r <= (delta_x_sqr + delta_y_sqr);
			state <= lo_1;
		end
		lo_1: begin//longest radius
			if ((delta_x_sqr + delta_y_sqr) > i_longest_r) begin
				o_work <= 1'b1;
				o_longest_r <= (delta_x_sqr + delta_y_sqr);
			end
			state <= finish;
		end
		// lo_2: begin
			// state <= finish;
		// end
		finish: begin
			o_done <= 1'b1;
			// o_shortest_r <= delta_x_sqr;
			// o_longest_r <= delta_y_sqr;
			state <= cal_r;
		end
		endcase
	end
end
endmodule

