module color_detector(
	input iclk,
	input ireset_n,
	
	input [10:0] icurrent_x,
	input [10:0] icurrent_y,
	
	// input [7:0] ired,
	// input [7:0] igreen,
	// input [7:0] iblue,
	input [7:0] iU,
	input [7:0] iV,
	
	
	// input [7:0] iRed_th,
	// input [7:0] iGreen_th,
	// input [7:0] iBlue_th,
	input [7:0] iU_th_high,
	input [7:0] iV_th_high,
	input [7:0] iU_th_low,
	input [7:0] iV_th_low,
	
	input [2:0] iradius,
	
	output reg odetected,
	output reg [10:0] ocenter_x,
	output reg [10:0] ocenter_y,
	
	output reg detect_iter,
	output [17:0] ledr

);

assign ledr[9:0] = ocenter_x_t;
assign ledr[15:10] = ocenter_y_t;
assign ledr[17] = detect_iter;
assign ledr[16] = odetected;

// reg detect_iter;
reg [7:0] detect_counter;
wire [3:0] length = (iradius<<1);
wire [7:0] area = length*length;
wire [7:0] correct_th = area-(area>>3);

reg [10:0] ocenter_x_t;
reg [10:0] ocenter_y_t;
	
	
always@(posedge iclk) begin
	if(!ireset_n) begin
		odetected <= 1'd0;
		detect_iter <= 1'd0;
		detect_counter <= 8'd0;
	end else begin
		if(!detect_iter) begin
			detect_counter <= 8'd0;
			ocenter_x_t <= icurrent_x+iradius;
			ocenter_y_t <= icurrent_y+iradius;
			
			if(icurrent_x>(20+iradius) && icurrent_x<(620-iradius) && icurrent_y>(20+iradius) && icurrent_y<(460-iradius)) begin
				if(iU<iU_th_high && iU>iU_th_low && iV<iV_th_high && iV>iV_th_low) begin
					detect_iter <= 1'd1;
				end else begin
					detect_iter <= 1'd0;				
				end
			end
		end else if(((ocenter_x_t+iradius)==icurrent_x) && ((ocenter_y_t+iradius)==icurrent_y)) begin
			
			detect_counter <= 1'd0;
			if(detect_counter > correct_th) begin
				odetected <= 1'd1;
				ocenter_x <= ocenter_x_t;
				ocenter_y <= ocenter_y_t;
			end else begin
				odetected <= 1'd0; 
				detect_iter <= 1'd0;
			end
		end else if(((ocenter_x_t+iradius)>=icurrent_x) && ((ocenter_y_t+iradius)>=icurrent_y) &&
					((ocenter_x_t-iradius)<=icurrent_x) && ((ocenter_y_t-iradius)<=icurrent_y)) begin
			if(iU<iU_th_high && iU>iU_th_low && iV<iV_th_high && iV>iV_th_low) begin
				detect_counter <= detect_counter+8'd1;
			end
		end
	end
	
	
	
end
	
endmodule