module vga_fall(
	input clk,
	input reset,
	
	input signed [10:0] ix1,
	input signed [10:0] iy1,
	
	input istart_fall,

	output reg [10:0] ox_out,
	output reg [10:0] oy_out,
	output reg odata,
	output reg owe,
	
	output reg oidle
);

parameter idle=4'd0, init=4'd1, init1=4'd2, init2=4'd3, init3=4'd4, loop=4'd5, loop1=4'd6, loop2=4'd7;
parameter endloop=4'd8;
reg [3:0] state;


reg signed [10:0] x,y;

always@(posedge clk) begin
	if(reset) begin
		state <=  idle;
		ox_out <= 1'd0;
		oy_out <= 1'd0;
		oidle <= 1'd0;
		owe <= 1'd0;
		odata <= 1'd0;
		
		x <= 0;
		y <= 0;
	end else begin
		case(state)
			idle:
			begin
				owe <= 1'd0;
				x <= ix1;
				y <= iy1;
				if(istart_fall) begin
					state <= init1;
					oidle <= 1'd0;
					
				end else begin
					oidle <= 1'd1;
				end
			end
			
			init1:
			begin
				ox_out <= x;
				oy_out <= y;
				owe <= 1'd0;
				odata <= 1'd0;
				
				state <= init2;
			end
			
			init2:
			begin
				
				owe <= 1'd1;
				odata <= 1'd0;
				
				
				state <= init3;
			end
			
			init3:
			begin
				owe <= 1'd1;
				
				state <= endloop;
			end
			
			// loop:
			// begin
				// ox_out <= x;
				// oy_out <= y+1;
				// owe <= 1'd1;
				// odata <= 1'd1;
				
				// state <= loop1;
			// end
			
			// loop1:
			// begin
				// owe <= 1'd1;
				// state <= loop2;
			// end
			
			// loop2:
			// begin
				// owe <= 1'd1;
				// state <= endloop;
				// oidle <= 1;
			// end
			
			endloop:
			begin
				owe <= 1'd0;
				oidle <= 1;
				state <= idle;
			end
		
		endcase
	end

end

endmodule